diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 3a87550ae..0e7b69eb7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -7,9 +7,20 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.block.ItemBlock;
+import org.useless.dragonfly.DisplayPos;
 
 public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
-    private static final ItemModelDispatcher instance = new ItemModelDispatcher();
+    protected static final DisplayPos HANDHELD_FIRST_PERSON_RIGHT_HAND = new DisplayPos(1.13f/16f, 3.2f/16f, 1.13f/16f, 0, -90, 25, 0.68f, 0.68f, 0.68f);
+    protected static final DisplayPos HANDHELD_FIRST_PERSON_LEFT_HAND = new DisplayPos(1.13f/16f, 3.2f/16f, 1.13f/16f, 0, 90, -25, 0.68f, 0.68f, 0.68f);
+    protected static final DisplayPos HANDHELD_THIRD_PERSON_RIGHT_HAND = new DisplayPos(0, 4.0f/16f, 0.5f/16f, 0, -90, 55, 0.85f, 0.85f, 0.85f);
+    protected static final DisplayPos HANDHELD_THIRD_PERSON_LEFT_HAND = new DisplayPos(0, 4.0f/16f, 0.5f/16f, 0,  90, -55, 0.85f, 0.85f, 0.85f);
+
+    protected static final DisplayPos HANDHELD_ROD_FIRST_PERSON_RIGHT_HAND = new DisplayPos(0/16f, 1.6f/16f, 0.8f/16f, 0, 90, 25, 0.68f, 0.68f, 0.68f);
+    protected static final DisplayPos HANDHELD_ROD_FIRST_PERSON_LEFT_HAND = new DisplayPos(0/16f, 1.6f/16f, 0.8f/16f, 0, -90, -25, 0.68f, 0.68f, 0.68f);
+    protected static final DisplayPos HANDHELD_ROD_THIRD_PERSON_RIGHT_HAND = new DisplayPos(0, 4.0f/16f, 2.5f/16f, 0, 90, 55, 0.85f, 0.85f, 0.85f);
+    protected static final DisplayPos HANDHELD_ROD_THIRD_PERSON_LEFT_HAND = new DisplayPos(0, 4.0f/16f, 2.5f/16f, 0,  -90, -55, 0.85f, 0.85f, 0.85f);
+
+    private static ItemModelDispatcher instance = new ItemModelDispatcher();
     public static final ItemModel emptyModel = new ItemModelNone();
 
     public static ItemModelDispatcher getInstance()
@@ -32,51 +43,165 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
     }
 
     private ItemModelDispatcher() {
-        addDispatch(new ItemModelStandard(Items.TOOL_SHOVEL_IRON, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_PICKAXE_IRON, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_AXE_IRON, "minecraft").setFull3D());
+        instance = this;
+        reload();
+    }
+
+    public void reload() {
+        dispatches.clear();
+        addDispatch(new ItemModelStandard(Items.TOOL_SHOVEL_IRON, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_PICKAXE_IRON, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_AXE_IRON, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
         addDispatch(new ItemModelStandard(Items.TOOL_FIRESTRIKER_IRON, "minecraft"));
 
         addDispatch(new ItemModelStandard(Items.FOOD_APPLE, "minecraft"));
-        addDispatch(new ItemModelBow(Items.TOOL_BOW, "minecraft"));
+        addDispatch(new ItemModelBow(Items.TOOL_BOW, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, new DisplayPos(1.13f/16f, 3.2f/16f, 1.13f/16f, 0, -90, 25, 0.68f, 0.68f, 0.68f))
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, new DisplayPos(1.13f/16f, 3.2f/16f, 1.13f/16f, 0, 90, -25, 0.68f, 0.68f, 0.68f))
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, new DisplayPos(-1f/16f, -2f/16f, 2.5f/16f, -80, 260, -40, 0.9f, 0.9f, 0.9f))
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, new DisplayPos(-1f/16f, -2f/16f, 2.5f/16f, -80, -280, 40, 0.9f, 0.9f, 0.9f)));
         addDispatch(new ItemModelStandard(Items.AMMO_ARROW, "minecraft"));
         addDispatch(new ItemModelCoal(Items.COAL, "minecraft"));
         addDispatch(new ItemModelStandard(Items.DIAMOND, "minecraft"));
         addDispatch(new ItemModelStandard(Items.INGOT_IRON, "minecraft"));
         addDispatch(new ItemModelStandard(Items.INGOT_GOLD, "minecraft"));
 
-        addDispatch(new ItemModelStandard(Items.TOOL_SWORD_IRON, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_SWORD_WOOD, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_SHOVEL_WOOD, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_PICKAXE_WOOD, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_AXE_WOOD, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_SWORD_STONE, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_SHOVEL_STONE, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_PICKAXE_STONE, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_AXE_STONE, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_SWORD_DIAMOND, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_SHOVEL_DIAMOND, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_PICKAXE_DIAMOND, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_AXE_DIAMOND, "minecraft").setFull3D());
-
-        addDispatch(new ItemModelStandard(Items.STICK, "minecraft").setFull3D());
+        addDispatch(new ItemModelStandard(Items.TOOL_SWORD_IRON, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_SWORD_WOOD, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_SHOVEL_WOOD, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_PICKAXE_WOOD, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_AXE_WOOD, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_SWORD_STONE, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_SHOVEL_STONE, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_PICKAXE_STONE, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_AXE_STONE, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_SWORD_DIAMOND, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_SHOVEL_DIAMOND, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_PICKAXE_DIAMOND, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_AXE_DIAMOND, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+
+        addDispatch(new ItemModelStandard(Items.STICK, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
         addDispatch(new ItemModelStandard(Items.BOWL, "minecraft"));
         addDispatch(new ItemModelStandard(Items.FOOD_STEW_MUSHROOM, "minecraft"));
 
-        addDispatch(new ItemModelStandard(Items.TOOL_SWORD_GOLD, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_SHOVEL_GOLD, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_PICKAXE_GOLD, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_AXE_GOLD, "minecraft").setFull3D());
+        addDispatch(new ItemModelStandard(Items.TOOL_SWORD_GOLD, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_SHOVEL_GOLD, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_PICKAXE_GOLD, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_AXE_GOLD, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
 
         addDispatch(new ItemModelStandard(Items.STRING, "minecraft"));
         addDispatch(new ItemModelStandard(Items.FEATHER_CHICKEN, "minecraft"));
         addDispatch(new ItemModelStandard(Items.SULPHUR, "minecraft"));
 
-        addDispatch(new ItemModelStandard(Items.TOOL_HOE_WOOD, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_HOE_STONE, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_HOE_IRON, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_HOE_DIAMOND, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_HOE_GOLD, "minecraft").setFull3D());
+        addDispatch(new ItemModelStandard(Items.TOOL_HOE_WOOD, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_HOE_STONE, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_HOE_IRON, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_HOE_DIAMOND, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_HOE_GOLD, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
 
         addDispatch(new ItemModelStandard(Items.SEEDS_WHEAT, "minecraft"));
         addDispatch(new ItemModelStandard(Items.WHEAT, "minecraft"));
@@ -137,13 +262,21 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Items.MINECART_FURNACE, "minecraft"));
         addDispatch(new ItemModelStandard(Items.EGG_CHICKEN, "minecraft"));
         addDispatch(new ItemModelStandard(Items.TOOL_COMPASS, "minecraft"));
-        addDispatch(new ItemModelFishingRod(Items.TOOL_FISHINGROD, "minecraft").setFull3D().setRotateWhenRendering());
+        addDispatch(new ItemModelFishingRod(Items.TOOL_FISHINGROD, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_ROD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_ROD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_ROD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_ROD_THIRD_PERSON_LEFT_HAND));
         addDispatch(new ItemModelStandard(Items.TOOL_CLOCK, "minecraft"));
         addDispatch(new ItemModelStandard(Items.DUST_GLOWSTONE, "minecraft").setFullBright());
         addDispatch(new ItemModelStandard(Items.FOOD_FISH_RAW, "minecraft"));
         addDispatch(new ItemModelStandard(Items.FOOD_FISH_COOKED, "minecraft"));
         addDispatch(new ItemModelDye(Items.DYE));
-        addDispatch(new ItemModelStandard(Items.BONE, "minecraft").setFull3D());
+        addDispatch(new ItemModelStandard(Items.BONE, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
         addDispatch(new ItemModelStandard(Items.DUST_SUGAR, "minecraft"));
         addDispatch(new ItemModelStandard(Items.FOOD_CAKE, "minecraft"));
         addDispatch(new ItemModelStandard(Items.FOOD_PUMPKIN_PIE, "minecraft"));
@@ -160,21 +293,49 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Items.ARMOR_LEGGINGS_STEEL, "minecraft"));
         addDispatch(new ItemModelStandard(Items.ARMOR_BOOTS_STEEL, "minecraft"));
 
-        addDispatch(new ItemModelStandard(Items.TOOL_SWORD_STEEL, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_SHOVEL_STEEL, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_PICKAXE_STEEL, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_AXE_STEEL, "minecraft").setFull3D());
-        addDispatch(new ItemModelStandard(Items.TOOL_HOE_STEEL, "minecraft").setFull3D());
+        addDispatch(new ItemModelStandard(Items.TOOL_SWORD_STEEL, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_SHOVEL_STEEL, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_PICKAXE_STEEL, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_AXE_STEEL, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.TOOL_HOE_STEEL, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
 
         addDispatch(new ItemModelStandard(Items.INGOT_STEEL, "minecraft"));
         addDispatch(new ItemModelStandard(Items.INGOT_STEEL_CRUDE, "minecraft"));
         addDispatch(new ItemModelStandard(Items.AMMO_FIREBALL, "minecraft").setFullBright());
         addDispatch(new ItemModelStandard(Items.ARMOR_QUIVER_GOLD, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.HANDCANNON_UNLOADED, "minecraft").setFull3D());
+        addDispatch(new ItemModelStandard(Items.HANDCANNON_UNLOADED, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
         addDispatch(new ItemModelStandard(Items.CHAINLINK, "minecraft"));
         addDispatch(new ItemModelStandard(Items.CLOTH, "minecraft"));
         addDispatch(new ItemModelStandard(Items.AMMO_CHARGE_EXPLOSIVE, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.HANDCANNON_LOADED, "minecraft").setFull3D().setFullBright());
+        addDispatch(new ItemModelStandard(Items.HANDCANNON_LOADED, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND).setFullBright());
         addDispatch(new ItemModelStandard(Items.AMMO_ARROW_GOLD, "minecraft"));
         addDispatch(new ItemModelQuiver(Items.ARMOR_QUIVER, "minecraft"));
         addDispatch(new ItemModelStandard(Items.TOOL_CALENDAR, "minecraft"));
@@ -195,7 +356,11 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Items.LANTERN_FIREFLY_RED, "minecraft").setFullBright());
 
         addDispatch(new ItemModelStandard(Items.BASKET, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.FLAG, "minecraft").setFull3D());
+        addDispatch(new ItemModelStandard(Items.FLAG, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
 
         addDispatch(new ItemModelStandard(Items.ARMOR_BOOTS_ICESKATES, "minecraft"));
         addDispatch(new ItemModelStandard(Items.TOOL_SHEARS_STEEL, "minecraft"));
@@ -205,9 +370,17 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
 
         addDispatch(new ItemModelStandard(Items.ROPE, "minecraft"));
 
-        addDispatch(new ItemModelStandard(Items.WAND_MONSTER_SPAWNER, "minecraft").setFull3D());
+        addDispatch(new ItemModelStandard(Items.WAND_MONSTER_SPAWNER, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
         addDispatch(new ItemModelStandard(Items.DOOR_STEEL, "minecraft"));
-        addDispatch(new ItemModelPaintbrush(Items.PAINTBRUSH, "minecraft").setFull3D());
+        addDispatch(new ItemModelPaintbrush(Items.PAINTBRUSH, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
 
         addDispatch(new ItemModelStandard(Items.RECORD_13, "minecraft"));
         addDispatch(new ItemModelStandard(Items.RECORD_CAT, "minecraft"));
@@ -236,6 +409,11 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_SILVER, "minecraft"));
 
         addDispatch(new ItemModelStandard(Items.STATUE_STONE, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.STATUE_BASALT, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.STATUE_LIMESTONE, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.STATUE_GRANITE, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.STATUE_MARBLE, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.STATUE_PIGMAN, "minecraft"));
 
         for (int i = 0; i < Blocks.blocksList.length; i++) {
             if (Blocks.blocksList[i] == null) continue;
